"""
    Time Series API For Digital Portals

    Time series data, end-of-day or intraday, tick-by-tick or subsampled. Additional vendor-specific endpoints provide a modified interface for seamless integration with the ChartIQ chart library.  This API is focused on high-performance applications that are  * serving millions of end-users, * accessible by client browsers via the internet, * integrated into complex infrastructures such as existing frontend frameworks or authentication services.  This API has been designed for direct use by client web applications and feature extreme low latency: The average response time across all endpoints is 30 ms whereas 99% of all requests are answered in close to under 300ms.  See the [Real-Time Quotes API for Digital Portals](https://developer.factset.com/api-catalog/real-time-quotes-api) for access to detailed price information.   # noqa: E501

    The version of the OpenAPI document: 3.0.0
    Contact: api@factset.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401
from multiprocessing.pool import ApplyResult
import typing

from fds.sdk.RealTimeTimeSeries.api_client import ApiClient, Endpoint as _Endpoint
from fds.sdk.RealTimeTimeSeries.model_utils import (  # noqa: F401
    check_allowed_values,
    check_validations,
    date,
    datetime,
    file_type,
    none_type,
    validate_and_convert_types
)
from fds.sdk.RealTimeTimeSeries.exceptions import ApiException
from fds.sdk.RealTimeTimeSeries.model.inline_response200 import InlineResponse200
from fds.sdk.RealTimeTimeSeries.model.inline_response2001 import InlineResponse2001
from fds.sdk.RealTimeTimeSeries.model.inline_response2002 import InlineResponse2002
from fds.sdk.RealTimeTimeSeries.model.inline_response2003 import InlineResponse2003
from fds.sdk.RealTimeTimeSeries.model.inline_response2004 import InlineResponse2004
from fds.sdk.RealTimeTimeSeries.model.post_vendor_chart_iq_time_series_eod_list_request import PostVendorChartIQTimeSeriesEodListRequest
from fds.sdk.RealTimeTimeSeries.model.post_vendor_chart_iq_time_series_eod_subsample_get_request import PostVendorChartIQTimeSeriesEodSubsampleGetRequest
from fds.sdk.RealTimeTimeSeries.model.post_vendor_chart_iq_time_series_eod_subsample_list_request import PostVendorChartIQTimeSeriesEodSubsampleListRequest
from fds.sdk.RealTimeTimeSeries.model.post_vendor_chart_iq_time_series_intraday_subsample_get_request import PostVendorChartIQTimeSeriesIntradaySubsampleGetRequest
from fds.sdk.RealTimeTimeSeries.model.post_vendor_chart_iq_time_series_intraday_subsample_list_request import PostVendorChartIQTimeSeriesIntradaySubsampleListRequest





class VendorApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

        self.post_vendor_chart_iq_time_series_eod_list_endpoint = _Endpoint(
            settings={
                'response_type': (
                  { 200: (InlineResponse200,),  },
                  None
                ),
                'auth': [
                    'FactSetApiKey',
                    'FactSetOAuth2'
                ],
                'endpoint_path': '/vendor/chartIQ/timeSeries/eod/list',
                'operation_id': 'post_vendor_chart_iq_time_series_eod_list',
                'http_method': 'POST',
                'servers': None,
            },
            params_map={
                'all': [
                    'post_vendor_chart_iq_time_series_eod_list_request',
                ],
                'required': [
                    'post_vendor_chart_iq_time_series_eod_list_request',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'post_vendor_chart_iq_time_series_eod_list_request':
                        (PostVendorChartIQTimeSeriesEodListRequest,),
                },
                'attribute_map': {
                },
                'location_map': {
                    'post_vendor_chart_iq_time_series_eod_list_request': 'body',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [
                    'application/json'
                ]
            },
            api_client=api_client
        )

        self.post_vendor_chart_iq_time_series_eod_subsample_get_endpoint = _Endpoint(
            settings={
                'response_type': (
                  { 200: (InlineResponse2001,),  },
                  None
                ),
                'auth': [
                    'FactSetApiKey',
                    'FactSetOAuth2'
                ],
                'endpoint_path': '/vendor/chartIQ/timeSeries/eod/subsample/get',
                'operation_id': 'post_vendor_chart_iq_time_series_eod_subsample_get',
                'http_method': 'POST',
                'servers': None,
            },
            params_map={
                'all': [
                    'post_vendor_chart_iq_time_series_eod_subsample_get_request',
                ],
                'required': [
                    'post_vendor_chart_iq_time_series_eod_subsample_get_request',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'post_vendor_chart_iq_time_series_eod_subsample_get_request':
                        (PostVendorChartIQTimeSeriesEodSubsampleGetRequest,),
                },
                'attribute_map': {
                },
                'location_map': {
                    'post_vendor_chart_iq_time_series_eod_subsample_get_request': 'body',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [
                    'application/json'
                ]
            },
            api_client=api_client
        )

        self.post_vendor_chart_iq_time_series_eod_subsample_list_endpoint = _Endpoint(
            settings={
                'response_type': (
                  { 200: (InlineResponse2002,),  },
                  None
                ),
                'auth': [
                    'FactSetApiKey',
                    'FactSetOAuth2'
                ],
                'endpoint_path': '/vendor/chartIQ/timeSeries/eod/subsample/list',
                'operation_id': 'post_vendor_chart_iq_time_series_eod_subsample_list',
                'http_method': 'POST',
                'servers': None,
            },
            params_map={
                'all': [
                    'post_vendor_chart_iq_time_series_eod_subsample_list_request',
                ],
                'required': [
                    'post_vendor_chart_iq_time_series_eod_subsample_list_request',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'post_vendor_chart_iq_time_series_eod_subsample_list_request':
                        (PostVendorChartIQTimeSeriesEodSubsampleListRequest,),
                },
                'attribute_map': {
                },
                'location_map': {
                    'post_vendor_chart_iq_time_series_eod_subsample_list_request': 'body',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [
                    'application/json'
                ]
            },
            api_client=api_client
        )

        self.post_vendor_chart_iq_time_series_intraday_subsample_get_endpoint = _Endpoint(
            settings={
                'response_type': (
                  { 200: (InlineResponse2003,),  },
                  None
                ),
                'auth': [
                    'FactSetApiKey',
                    'FactSetOAuth2'
                ],
                'endpoint_path': '/vendor/chartIQ/timeSeries/intraday/subsample/get',
                'operation_id': 'post_vendor_chart_iq_time_series_intraday_subsample_get',
                'http_method': 'POST',
                'servers': None,
            },
            params_map={
                'all': [
                    'post_vendor_chart_iq_time_series_intraday_subsample_get_request',
                ],
                'required': [
                    'post_vendor_chart_iq_time_series_intraday_subsample_get_request',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'post_vendor_chart_iq_time_series_intraday_subsample_get_request':
                        (PostVendorChartIQTimeSeriesIntradaySubsampleGetRequest,),
                },
                'attribute_map': {
                },
                'location_map': {
                    'post_vendor_chart_iq_time_series_intraday_subsample_get_request': 'body',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [
                    'application/json'
                ]
            },
            api_client=api_client
        )

        self.post_vendor_chart_iq_time_series_intraday_subsample_list_endpoint = _Endpoint(
            settings={
                'response_type': (
                  { 200: (InlineResponse2004,),  },
                  None
                ),
                'auth': [
                    'FactSetApiKey',
                    'FactSetOAuth2'
                ],
                'endpoint_path': '/vendor/chartIQ/timeSeries/intraday/subsample/list',
                'operation_id': 'post_vendor_chart_iq_time_series_intraday_subsample_list',
                'http_method': 'POST',
                'servers': None,
            },
            params_map={
                'all': [
                    'post_vendor_chart_iq_time_series_intraday_subsample_list_request',
                ],
                'required': [
                    'post_vendor_chart_iq_time_series_intraday_subsample_list_request',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'post_vendor_chart_iq_time_series_intraday_subsample_list_request':
                        (PostVendorChartIQTimeSeriesIntradaySubsampleListRequest,),
                },
                'attribute_map': {
                },
                'location_map': {
                    'post_vendor_chart_iq_time_series_intraday_subsample_list_request': 'body',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [
                    'application/json'
                ]
            },
            api_client=api_client
        )


    @staticmethod
    def apply_kwargs_defaults(kwargs, return_http_data_only, async_req):
        kwargs["async_req"] = async_req
        kwargs["_return_http_data_only"] = return_http_data_only
        kwargs["_preload_content"] = kwargs.get("_preload_content", True)
        kwargs["_request_timeout"] = kwargs.get("_request_timeout", None)
        kwargs["_check_input_type"] = kwargs.get("_check_input_type", True)
        kwargs["_check_return_type"] = kwargs.get("_check_return_type", True)
        kwargs["_spec_property_naming"] = kwargs.get("_spec_property_naming", False)
        kwargs["_content_type"] = kwargs.get("_content_type")
        kwargs["_host_index"] = kwargs.get("_host_index")


    def post_vendor_chart_iq_time_series_eod_list(
        self,
        post_vendor_chart_iq_time_series_eod_list_request,
        **kwargs
    ) -> InlineResponse200:
        """End-of-day time series data for a notation.  # noqa: E501

        End-of-day time series data for a notation. The resulting time series is always adjusted for currency changes.<br><br>Pagination to a previous page is not supported and `pagination.previous` is always `null`.  # noqa: E501
        This method makes a synchronous HTTP request. Returns the http data only

        Args:
            post_vendor_chart_iq_time_series_eod_list_request (PostVendorChartIQTimeSeriesEodListRequest): Request Body

        Keyword Args:
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True. NOTE: if this API returns a file, it is the responsibility
                of the caller to close the file stream.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
        Returns:
            InlineResponse200
                Response Object
        """
        self.apply_kwargs_defaults(kwargs=kwargs, return_http_data_only=True, async_req=False)
        kwargs['post_vendor_chart_iq_time_series_eod_list_request'] = \
            post_vendor_chart_iq_time_series_eod_list_request
        return self.post_vendor_chart_iq_time_series_eod_list_endpoint.call_with_http_info(**kwargs)

    def post_vendor_chart_iq_time_series_eod_list_with_http_info(
        self,
        post_vendor_chart_iq_time_series_eod_list_request,
        **kwargs
    ) -> typing.Tuple[InlineResponse200, int, typing.MutableMapping]:
        """End-of-day time series data for a notation.  # noqa: E501

        End-of-day time series data for a notation. The resulting time series is always adjusted for currency changes.<br><br>Pagination to a previous page is not supported and `pagination.previous` is always `null`.  # noqa: E501
        This method makes a synchronous HTTP request. Returns http data, http status and headers

        Args:
            post_vendor_chart_iq_time_series_eod_list_request (PostVendorChartIQTimeSeriesEodListRequest): Request Body

        Keyword Args:
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True. NOTE: if this API returns a file, it is the responsibility
                of the caller to close the file stream.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
        Returns:
            InlineResponse200
                Response Object
            int
                Http Status Code
            dict
                Dictionary of the response headers
        """
        self.apply_kwargs_defaults(kwargs=kwargs, return_http_data_only=False, async_req=False)
        kwargs['post_vendor_chart_iq_time_series_eod_list_request'] = \
            post_vendor_chart_iq_time_series_eod_list_request
        return self.post_vendor_chart_iq_time_series_eod_list_endpoint.call_with_http_info(**kwargs)

    def post_vendor_chart_iq_time_series_eod_list_async(
        self,
        post_vendor_chart_iq_time_series_eod_list_request,
        **kwargs
    ) -> "ApplyResult[InlineResponse200]":
        """End-of-day time series data for a notation.  # noqa: E501

        End-of-day time series data for a notation. The resulting time series is always adjusted for currency changes.<br><br>Pagination to a previous page is not supported and `pagination.previous` is always `null`.  # noqa: E501
        This method makes a asynchronous HTTP request. Returns the http data, wrapped in ApplyResult

        Args:
            post_vendor_chart_iq_time_series_eod_list_request (PostVendorChartIQTimeSeriesEodListRequest): Request Body

        Keyword Args:
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True. NOTE: if this API returns a file, it is the responsibility
                of the caller to close the file stream.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
        Returns:
            ApplyResult[InlineResponse200]
        """
        self.apply_kwargs_defaults(kwargs=kwargs, return_http_data_only=True, async_req=True)
        kwargs['post_vendor_chart_iq_time_series_eod_list_request'] = \
            post_vendor_chart_iq_time_series_eod_list_request
        return self.post_vendor_chart_iq_time_series_eod_list_endpoint.call_with_http_info(**kwargs)

    def post_vendor_chart_iq_time_series_eod_list_with_http_info_async(
        self,
        post_vendor_chart_iq_time_series_eod_list_request,
        **kwargs
    ) -> "ApplyResult[typing.Tuple[InlineResponse200, int, typing.MutableMapping]]":
        """End-of-day time series data for a notation.  # noqa: E501

        End-of-day time series data for a notation. The resulting time series is always adjusted for currency changes.<br><br>Pagination to a previous page is not supported and `pagination.previous` is always `null`.  # noqa: E501
        This method makes a asynchronous HTTP request. Returns http data, http status and headers, wrapped in ApplyResult

        Args:
            post_vendor_chart_iq_time_series_eod_list_request (PostVendorChartIQTimeSeriesEodListRequest): Request Body

        Keyword Args:
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True. NOTE: if this API returns a file, it is the responsibility
                of the caller to close the file stream.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
        Returns:
            ApplyResult[(InlineResponse200, int, typing.Dict)]
        """
        self.apply_kwargs_defaults(kwargs=kwargs, return_http_data_only=False, async_req=True)
        kwargs['post_vendor_chart_iq_time_series_eod_list_request'] = \
            post_vendor_chart_iq_time_series_eod_list_request
        return self.post_vendor_chart_iq_time_series_eod_list_endpoint.call_with_http_info(**kwargs)


    def post_vendor_chart_iq_time_series_eod_subsample_get(
        self,
        post_vendor_chart_iq_time_series_eod_subsample_get_request,
        **kwargs
    ) -> InlineResponse2001:
        """Single subsample end-of-day data for a notation.  # noqa: E501

        Single subsample end-of-day data for a notation. The sample is always adjusted for currency changes. The subsample may exceed the entitled date range, but will be based only on days that are in the entitled range.  # noqa: E501
        This method makes a synchronous HTTP request. Returns the http data only

        Args:
            post_vendor_chart_iq_time_series_eod_subsample_get_request (PostVendorChartIQTimeSeriesEodSubsampleGetRequest): Request Body

        Keyword Args:
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True. NOTE: if this API returns a file, it is the responsibility
                of the caller to close the file stream.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
        Returns:
            InlineResponse2001
                Response Object
        """
        self.apply_kwargs_defaults(kwargs=kwargs, return_http_data_only=True, async_req=False)
        kwargs['post_vendor_chart_iq_time_series_eod_subsample_get_request'] = \
            post_vendor_chart_iq_time_series_eod_subsample_get_request
        return self.post_vendor_chart_iq_time_series_eod_subsample_get_endpoint.call_with_http_info(**kwargs)

    def post_vendor_chart_iq_time_series_eod_subsample_get_with_http_info(
        self,
        post_vendor_chart_iq_time_series_eod_subsample_get_request,
        **kwargs
    ) -> typing.Tuple[InlineResponse2001, int, typing.MutableMapping]:
        """Single subsample end-of-day data for a notation.  # noqa: E501

        Single subsample end-of-day data for a notation. The sample is always adjusted for currency changes. The subsample may exceed the entitled date range, but will be based only on days that are in the entitled range.  # noqa: E501
        This method makes a synchronous HTTP request. Returns http data, http status and headers

        Args:
            post_vendor_chart_iq_time_series_eod_subsample_get_request (PostVendorChartIQTimeSeriesEodSubsampleGetRequest): Request Body

        Keyword Args:
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True. NOTE: if this API returns a file, it is the responsibility
                of the caller to close the file stream.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
        Returns:
            InlineResponse2001
                Response Object
            int
                Http Status Code
            dict
                Dictionary of the response headers
        """
        self.apply_kwargs_defaults(kwargs=kwargs, return_http_data_only=False, async_req=False)
        kwargs['post_vendor_chart_iq_time_series_eod_subsample_get_request'] = \
            post_vendor_chart_iq_time_series_eod_subsample_get_request
        return self.post_vendor_chart_iq_time_series_eod_subsample_get_endpoint.call_with_http_info(**kwargs)

    def post_vendor_chart_iq_time_series_eod_subsample_get_async(
        self,
        post_vendor_chart_iq_time_series_eod_subsample_get_request,
        **kwargs
    ) -> "ApplyResult[InlineResponse2001]":
        """Single subsample end-of-day data for a notation.  # noqa: E501

        Single subsample end-of-day data for a notation. The sample is always adjusted for currency changes. The subsample may exceed the entitled date range, but will be based only on days that are in the entitled range.  # noqa: E501
        This method makes a asynchronous HTTP request. Returns the http data, wrapped in ApplyResult

        Args:
            post_vendor_chart_iq_time_series_eod_subsample_get_request (PostVendorChartIQTimeSeriesEodSubsampleGetRequest): Request Body

        Keyword Args:
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True. NOTE: if this API returns a file, it is the responsibility
                of the caller to close the file stream.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
        Returns:
            ApplyResult[InlineResponse2001]
        """
        self.apply_kwargs_defaults(kwargs=kwargs, return_http_data_only=True, async_req=True)
        kwargs['post_vendor_chart_iq_time_series_eod_subsample_get_request'] = \
            post_vendor_chart_iq_time_series_eod_subsample_get_request
        return self.post_vendor_chart_iq_time_series_eod_subsample_get_endpoint.call_with_http_info(**kwargs)

    def post_vendor_chart_iq_time_series_eod_subsample_get_with_http_info_async(
        self,
        post_vendor_chart_iq_time_series_eod_subsample_get_request,
        **kwargs
    ) -> "ApplyResult[typing.Tuple[InlineResponse2001, int, typing.MutableMapping]]":
        """Single subsample end-of-day data for a notation.  # noqa: E501

        Single subsample end-of-day data for a notation. The sample is always adjusted for currency changes. The subsample may exceed the entitled date range, but will be based only on days that are in the entitled range.  # noqa: E501
        This method makes a asynchronous HTTP request. Returns http data, http status and headers, wrapped in ApplyResult

        Args:
            post_vendor_chart_iq_time_series_eod_subsample_get_request (PostVendorChartIQTimeSeriesEodSubsampleGetRequest): Request Body

        Keyword Args:
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True. NOTE: if this API returns a file, it is the responsibility
                of the caller to close the file stream.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
        Returns:
            ApplyResult[(InlineResponse2001, int, typing.Dict)]
        """
        self.apply_kwargs_defaults(kwargs=kwargs, return_http_data_only=False, async_req=True)
        kwargs['post_vendor_chart_iq_time_series_eod_subsample_get_request'] = \
            post_vendor_chart_iq_time_series_eod_subsample_get_request
        return self.post_vendor_chart_iq_time_series_eod_subsample_get_endpoint.call_with_http_info(**kwargs)


    def post_vendor_chart_iq_time_series_eod_subsample_list(
        self,
        post_vendor_chart_iq_time_series_eod_subsample_list_request,
        **kwargs
    ) -> InlineResponse2002:
        """Subsampled end-of-day time series data for a notation.  # noqa: E501

        Subsampled end-of-day time series data for a notation. The resulting time series is always adjusted for currency changes. If a subsample's date range is not entirely within the maximally entitled date range, the subsample is excluded from the response.<br><br>Pagination to a previous page is not supported and `pagination.previous` is always `null`.  # noqa: E501
        This method makes a synchronous HTTP request. Returns the http data only

        Args:
            post_vendor_chart_iq_time_series_eod_subsample_list_request (PostVendorChartIQTimeSeriesEodSubsampleListRequest): Request Body

        Keyword Args:
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True. NOTE: if this API returns a file, it is the responsibility
                of the caller to close the file stream.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
        Returns:
            InlineResponse2002
                Response Object
        """
        self.apply_kwargs_defaults(kwargs=kwargs, return_http_data_only=True, async_req=False)
        kwargs['post_vendor_chart_iq_time_series_eod_subsample_list_request'] = \
            post_vendor_chart_iq_time_series_eod_subsample_list_request
        return self.post_vendor_chart_iq_time_series_eod_subsample_list_endpoint.call_with_http_info(**kwargs)

    def post_vendor_chart_iq_time_series_eod_subsample_list_with_http_info(
        self,
        post_vendor_chart_iq_time_series_eod_subsample_list_request,
        **kwargs
    ) -> typing.Tuple[InlineResponse2002, int, typing.MutableMapping]:
        """Subsampled end-of-day time series data for a notation.  # noqa: E501

        Subsampled end-of-day time series data for a notation. The resulting time series is always adjusted for currency changes. If a subsample's date range is not entirely within the maximally entitled date range, the subsample is excluded from the response.<br><br>Pagination to a previous page is not supported and `pagination.previous` is always `null`.  # noqa: E501
        This method makes a synchronous HTTP request. Returns http data, http status and headers

        Args:
            post_vendor_chart_iq_time_series_eod_subsample_list_request (PostVendorChartIQTimeSeriesEodSubsampleListRequest): Request Body

        Keyword Args:
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True. NOTE: if this API returns a file, it is the responsibility
                of the caller to close the file stream.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
        Returns:
            InlineResponse2002
                Response Object
            int
                Http Status Code
            dict
                Dictionary of the response headers
        """
        self.apply_kwargs_defaults(kwargs=kwargs, return_http_data_only=False, async_req=False)
        kwargs['post_vendor_chart_iq_time_series_eod_subsample_list_request'] = \
            post_vendor_chart_iq_time_series_eod_subsample_list_request
        return self.post_vendor_chart_iq_time_series_eod_subsample_list_endpoint.call_with_http_info(**kwargs)

    def post_vendor_chart_iq_time_series_eod_subsample_list_async(
        self,
        post_vendor_chart_iq_time_series_eod_subsample_list_request,
        **kwargs
    ) -> "ApplyResult[InlineResponse2002]":
        """Subsampled end-of-day time series data for a notation.  # noqa: E501

        Subsampled end-of-day time series data for a notation. The resulting time series is always adjusted for currency changes. If a subsample's date range is not entirely within the maximally entitled date range, the subsample is excluded from the response.<br><br>Pagination to a previous page is not supported and `pagination.previous` is always `null`.  # noqa: E501
        This method makes a asynchronous HTTP request. Returns the http data, wrapped in ApplyResult

        Args:
            post_vendor_chart_iq_time_series_eod_subsample_list_request (PostVendorChartIQTimeSeriesEodSubsampleListRequest): Request Body

        Keyword Args:
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True. NOTE: if this API returns a file, it is the responsibility
                of the caller to close the file stream.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
        Returns:
            ApplyResult[InlineResponse2002]
        """
        self.apply_kwargs_defaults(kwargs=kwargs, return_http_data_only=True, async_req=True)
        kwargs['post_vendor_chart_iq_time_series_eod_subsample_list_request'] = \
            post_vendor_chart_iq_time_series_eod_subsample_list_request
        return self.post_vendor_chart_iq_time_series_eod_subsample_list_endpoint.call_with_http_info(**kwargs)

    def post_vendor_chart_iq_time_series_eod_subsample_list_with_http_info_async(
        self,
        post_vendor_chart_iq_time_series_eod_subsample_list_request,
        **kwargs
    ) -> "ApplyResult[typing.Tuple[InlineResponse2002, int, typing.MutableMapping]]":
        """Subsampled end-of-day time series data for a notation.  # noqa: E501

        Subsampled end-of-day time series data for a notation. The resulting time series is always adjusted for currency changes. If a subsample's date range is not entirely within the maximally entitled date range, the subsample is excluded from the response.<br><br>Pagination to a previous page is not supported and `pagination.previous` is always `null`.  # noqa: E501
        This method makes a asynchronous HTTP request. Returns http data, http status and headers, wrapped in ApplyResult

        Args:
            post_vendor_chart_iq_time_series_eod_subsample_list_request (PostVendorChartIQTimeSeriesEodSubsampleListRequest): Request Body

        Keyword Args:
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True. NOTE: if this API returns a file, it is the responsibility
                of the caller to close the file stream.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
        Returns:
            ApplyResult[(InlineResponse2002, int, typing.Dict)]
        """
        self.apply_kwargs_defaults(kwargs=kwargs, return_http_data_only=False, async_req=True)
        kwargs['post_vendor_chart_iq_time_series_eod_subsample_list_request'] = \
            post_vendor_chart_iq_time_series_eod_subsample_list_request
        return self.post_vendor_chart_iq_time_series_eod_subsample_list_endpoint.call_with_http_info(**kwargs)


    def post_vendor_chart_iq_time_series_intraday_subsample_get(
        self,
        post_vendor_chart_iq_time_series_intraday_subsample_get_request,
        **kwargs
    ) -> InlineResponse2003:
        """Single subsample intraday data for a notation.  # noqa: E501

        Single subsample intraday data for a notation. The subsample may exceed the entitled time range, but will be based only on ticks that are in the entitled range.  # noqa: E501
        This method makes a synchronous HTTP request. Returns the http data only

        Args:
            post_vendor_chart_iq_time_series_intraday_subsample_get_request (PostVendorChartIQTimeSeriesIntradaySubsampleGetRequest): Request Body

        Keyword Args:
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True. NOTE: if this API returns a file, it is the responsibility
                of the caller to close the file stream.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
        Returns:
            InlineResponse2003
                Response Object
        """
        self.apply_kwargs_defaults(kwargs=kwargs, return_http_data_only=True, async_req=False)
        kwargs['post_vendor_chart_iq_time_series_intraday_subsample_get_request'] = \
            post_vendor_chart_iq_time_series_intraday_subsample_get_request
        return self.post_vendor_chart_iq_time_series_intraday_subsample_get_endpoint.call_with_http_info(**kwargs)

    def post_vendor_chart_iq_time_series_intraday_subsample_get_with_http_info(
        self,
        post_vendor_chart_iq_time_series_intraday_subsample_get_request,
        **kwargs
    ) -> typing.Tuple[InlineResponse2003, int, typing.MutableMapping]:
        """Single subsample intraday data for a notation.  # noqa: E501

        Single subsample intraday data for a notation. The subsample may exceed the entitled time range, but will be based only on ticks that are in the entitled range.  # noqa: E501
        This method makes a synchronous HTTP request. Returns http data, http status and headers

        Args:
            post_vendor_chart_iq_time_series_intraday_subsample_get_request (PostVendorChartIQTimeSeriesIntradaySubsampleGetRequest): Request Body

        Keyword Args:
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True. NOTE: if this API returns a file, it is the responsibility
                of the caller to close the file stream.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
        Returns:
            InlineResponse2003
                Response Object
            int
                Http Status Code
            dict
                Dictionary of the response headers
        """
        self.apply_kwargs_defaults(kwargs=kwargs, return_http_data_only=False, async_req=False)
        kwargs['post_vendor_chart_iq_time_series_intraday_subsample_get_request'] = \
            post_vendor_chart_iq_time_series_intraday_subsample_get_request
        return self.post_vendor_chart_iq_time_series_intraday_subsample_get_endpoint.call_with_http_info(**kwargs)

    def post_vendor_chart_iq_time_series_intraday_subsample_get_async(
        self,
        post_vendor_chart_iq_time_series_intraday_subsample_get_request,
        **kwargs
    ) -> "ApplyResult[InlineResponse2003]":
        """Single subsample intraday data for a notation.  # noqa: E501

        Single subsample intraday data for a notation. The subsample may exceed the entitled time range, but will be based only on ticks that are in the entitled range.  # noqa: E501
        This method makes a asynchronous HTTP request. Returns the http data, wrapped in ApplyResult

        Args:
            post_vendor_chart_iq_time_series_intraday_subsample_get_request (PostVendorChartIQTimeSeriesIntradaySubsampleGetRequest): Request Body

        Keyword Args:
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True. NOTE: if this API returns a file, it is the responsibility
                of the caller to close the file stream.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
        Returns:
            ApplyResult[InlineResponse2003]
        """
        self.apply_kwargs_defaults(kwargs=kwargs, return_http_data_only=True, async_req=True)
        kwargs['post_vendor_chart_iq_time_series_intraday_subsample_get_request'] = \
            post_vendor_chart_iq_time_series_intraday_subsample_get_request
        return self.post_vendor_chart_iq_time_series_intraday_subsample_get_endpoint.call_with_http_info(**kwargs)

    def post_vendor_chart_iq_time_series_intraday_subsample_get_with_http_info_async(
        self,
        post_vendor_chart_iq_time_series_intraday_subsample_get_request,
        **kwargs
    ) -> "ApplyResult[typing.Tuple[InlineResponse2003, int, typing.MutableMapping]]":
        """Single subsample intraday data for a notation.  # noqa: E501

        Single subsample intraday data for a notation. The subsample may exceed the entitled time range, but will be based only on ticks that are in the entitled range.  # noqa: E501
        This method makes a asynchronous HTTP request. Returns http data, http status and headers, wrapped in ApplyResult

        Args:
            post_vendor_chart_iq_time_series_intraday_subsample_get_request (PostVendorChartIQTimeSeriesIntradaySubsampleGetRequest): Request Body

        Keyword Args:
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True. NOTE: if this API returns a file, it is the responsibility
                of the caller to close the file stream.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
        Returns:
            ApplyResult[(InlineResponse2003, int, typing.Dict)]
        """
        self.apply_kwargs_defaults(kwargs=kwargs, return_http_data_only=False, async_req=True)
        kwargs['post_vendor_chart_iq_time_series_intraday_subsample_get_request'] = \
            post_vendor_chart_iq_time_series_intraday_subsample_get_request
        return self.post_vendor_chart_iq_time_series_intraday_subsample_get_endpoint.call_with_http_info(**kwargs)


    def post_vendor_chart_iq_time_series_intraday_subsample_list(
        self,
        post_vendor_chart_iq_time_series_intraday_subsample_list_request,
        **kwargs
    ) -> InlineResponse2004:
        """Subsampled intraday time series data for a notation.  # noqa: E501

        Subsampled intraday time series data for a notation. If a subsample's time range is not entirely within the maximally entitled time range, the subsample is excluded from the response.<br><br>Pagination to a previous page is not supported and `pagination.previous` is always `null`.  # noqa: E501
        This method makes a synchronous HTTP request. Returns the http data only

        Args:
            post_vendor_chart_iq_time_series_intraday_subsample_list_request (PostVendorChartIQTimeSeriesIntradaySubsampleListRequest): Request Body

        Keyword Args:
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True. NOTE: if this API returns a file, it is the responsibility
                of the caller to close the file stream.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
        Returns:
            InlineResponse2004
                Response Object
        """
        self.apply_kwargs_defaults(kwargs=kwargs, return_http_data_only=True, async_req=False)
        kwargs['post_vendor_chart_iq_time_series_intraday_subsample_list_request'] = \
            post_vendor_chart_iq_time_series_intraday_subsample_list_request
        return self.post_vendor_chart_iq_time_series_intraday_subsample_list_endpoint.call_with_http_info(**kwargs)

    def post_vendor_chart_iq_time_series_intraday_subsample_list_with_http_info(
        self,
        post_vendor_chart_iq_time_series_intraday_subsample_list_request,
        **kwargs
    ) -> typing.Tuple[InlineResponse2004, int, typing.MutableMapping]:
        """Subsampled intraday time series data for a notation.  # noqa: E501

        Subsampled intraday time series data for a notation. If a subsample's time range is not entirely within the maximally entitled time range, the subsample is excluded from the response.<br><br>Pagination to a previous page is not supported and `pagination.previous` is always `null`.  # noqa: E501
        This method makes a synchronous HTTP request. Returns http data, http status and headers

        Args:
            post_vendor_chart_iq_time_series_intraday_subsample_list_request (PostVendorChartIQTimeSeriesIntradaySubsampleListRequest): Request Body

        Keyword Args:
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True. NOTE: if this API returns a file, it is the responsibility
                of the caller to close the file stream.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
        Returns:
            InlineResponse2004
                Response Object
            int
                Http Status Code
            dict
                Dictionary of the response headers
        """
        self.apply_kwargs_defaults(kwargs=kwargs, return_http_data_only=False, async_req=False)
        kwargs['post_vendor_chart_iq_time_series_intraday_subsample_list_request'] = \
            post_vendor_chart_iq_time_series_intraday_subsample_list_request
        return self.post_vendor_chart_iq_time_series_intraday_subsample_list_endpoint.call_with_http_info(**kwargs)

    def post_vendor_chart_iq_time_series_intraday_subsample_list_async(
        self,
        post_vendor_chart_iq_time_series_intraday_subsample_list_request,
        **kwargs
    ) -> "ApplyResult[InlineResponse2004]":
        """Subsampled intraday time series data for a notation.  # noqa: E501

        Subsampled intraday time series data for a notation. If a subsample's time range is not entirely within the maximally entitled time range, the subsample is excluded from the response.<br><br>Pagination to a previous page is not supported and `pagination.previous` is always `null`.  # noqa: E501
        This method makes a asynchronous HTTP request. Returns the http data, wrapped in ApplyResult

        Args:
            post_vendor_chart_iq_time_series_intraday_subsample_list_request (PostVendorChartIQTimeSeriesIntradaySubsampleListRequest): Request Body

        Keyword Args:
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True. NOTE: if this API returns a file, it is the responsibility
                of the caller to close the file stream.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
        Returns:
            ApplyResult[InlineResponse2004]
        """
        self.apply_kwargs_defaults(kwargs=kwargs, return_http_data_only=True, async_req=True)
        kwargs['post_vendor_chart_iq_time_series_intraday_subsample_list_request'] = \
            post_vendor_chart_iq_time_series_intraday_subsample_list_request
        return self.post_vendor_chart_iq_time_series_intraday_subsample_list_endpoint.call_with_http_info(**kwargs)

    def post_vendor_chart_iq_time_series_intraday_subsample_list_with_http_info_async(
        self,
        post_vendor_chart_iq_time_series_intraday_subsample_list_request,
        **kwargs
    ) -> "ApplyResult[typing.Tuple[InlineResponse2004, int, typing.MutableMapping]]":
        """Subsampled intraday time series data for a notation.  # noqa: E501

        Subsampled intraday time series data for a notation. If a subsample's time range is not entirely within the maximally entitled time range, the subsample is excluded from the response.<br><br>Pagination to a previous page is not supported and `pagination.previous` is always `null`.  # noqa: E501
        This method makes a asynchronous HTTP request. Returns http data, http status and headers, wrapped in ApplyResult

        Args:
            post_vendor_chart_iq_time_series_intraday_subsample_list_request (PostVendorChartIQTimeSeriesIntradaySubsampleListRequest): Request Body

        Keyword Args:
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True. NOTE: if this API returns a file, it is the responsibility
                of the caller to close the file stream.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
        Returns:
            ApplyResult[(InlineResponse2004, int, typing.Dict)]
        """
        self.apply_kwargs_defaults(kwargs=kwargs, return_http_data_only=False, async_req=True)
        kwargs['post_vendor_chart_iq_time_series_intraday_subsample_list_request'] = \
            post_vendor_chart_iq_time_series_intraday_subsample_list_request
        return self.post_vendor_chart_iq_time_series_intraday_subsample_list_endpoint.call_with_http_info(**kwargs)


